﻿/*
 * This class represents a single move.  
 * Internally, it uses  x1 y1 x2 y2    where the x's and y's are 0-3 to represent a move
 * on the board.   if x1 = 4 then it is a move from a stack, y1 is 0-2 to represent which
 * stack, and then x2 y2 is the destination on the board.
 * 
 * The internal format is mapped to the game manager format by getMove()
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Gobblet
{
    class Move
    {
        private int x1, y1, x2, y2;

        public Move(int x1, int y1, int x2, int y2)
        {
            this.x1 = x1;
            this.x2 = x2;
            this.y1 = y1;
            this.y2 = y2;
        }

        public int Y2
        {
            get { return y2; }
            set { y2 = value; }
        }

        public int X2
        {
            get { return x2; }
            set { x2 = value; }
        }

        public int Y1
        {
            get { return y1; }
            set { y1 = value; }
        }

        public int X1
        {
            get { return x1; }
            set { x1 = value; }
        }

        public override String ToString()
        {
            return Convert.ToString(x1) + " " + Convert.ToString(y1) + " " + Convert.ToString(x2) + " " + Convert.ToString(y2);

        }

        /*
         *  Map internal move format to the game manager move format.
         */
        public String getMove(int whoseturn)
        {
            if (whoseturn == frmGobblet.WHITE)
            {
                return Convert.ToString(x1 + 1) + Convert.ToString(y1 + 1) + Convert.ToString(x2 + 1) + Convert.ToString(y2 + 1);                
            }
            else
            {
                if (x1 == 4)
                    return Convert.ToString(x1 + 2) + Convert.ToString(y1 + 1) + Convert.ToString(x2 + 1) + Convert.ToString(y2 + 1);
                else
                    return Convert.ToString(x1 + 1) + Convert.ToString(y1 + 1) + Convert.ToString(x2 + 1) + Convert.ToString(y2 + 1);
            }
        }
    }
}
